import { loadScript, querystring, getCookie } from './util'
import { segment } from './segment'
import { demandbase } from './demandbase'

let key

function post (name, data) {
  return window.fetch('/eloqua', {
    body: JSON.stringify({
      elqSiteID: key,
      elqFormName: name,
      elqCustomerGUID: window.GetElqCustomerGUID ? window.GetElqCustomerGUID() : '',
      elqCookieWrite: 0,
      url: window.location.href,
      gclid: window.sessionStorage.getItem('gclid') || '',
      jump_id: querystring().jmp || window.sessionStorage.getItem('jmp') || getCookie('jmp') || '',
      anonymousId: segment.anonymousId(),
      ...demandbase.profileValues(),
      ...data
    }),
    credentials: 'include',
    headers: { 'content-type': 'application/json' },
    method: 'POST'
  }).then(function (response) {
    return response.text()
  }).then(function (response) {
    const el = document.createElement('html')
    el.innerHTML = response

    const script = el.querySelector('script')

    return {
      html: response,
      success: script && script.innerHTML.trim().split('=')[1].includes('Confirmation')
    }
  })
}

function load (k) {
  key = k

  loadScript({
    id: 'eloqua_js_lib_dynamic',
    src: '//img03.en25.com/i/elqCfg.min.js',
    onload () {
      window._elqQ.push(['elqSetSiteId', key])
      window._elqQ.push(['elqTrackPageView'])
      window._elqQ.push(['elqGetCustomerGUID'])
    }
  })
}

export const eloqua = { load, post }
